<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/Directory.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/Directory.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/Directory.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">import</span> os, stat, os.path, time, re</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory.html#compile_glob">compile_glob</a>(globstr):</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Returns a compiled regular expression for the given glob string. A</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">    glob string is something like &quot;*.?pp&quot; which gets translated into</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">    &quot;^.*\..pp$&quot;.&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    glob = globstr.replace(<span class="py-string">'.'</span>, <span class="py-string">'\.'</span>)</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    glob = glob.replace(<span class="py-string">'?'</span>, <span class="py-string">'.'</span>)</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">    glob = glob.replace(<span class="py-string">'*'</span>, <span class="py-string">'.*'</span>)</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    glob = re.compile(<span class="py-string">'^%s$'</span>%glob)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-keyword">return</span> glob</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html">Directory</a>(View):</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A view that lists the content of a directory.&quot;&quot;&quot;</span></span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">    src_dir = Parameter(<span class="py-string">''</span>, <span class="py-string">'starting point for directory listing'</span>)</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">    base_path = Parameter(<span class="py-string">''</span>, <span class="py-string">'path prefix to strip off of the file names'</span>)</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    exclude = Parameter([], <span class="py-string">'TODO: define an exclusion mechanism (glob based ?)'</span>)</span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#filename">filename</a>(self):</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-keyword">return</span> self.__filename</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#title">title</a>(self):</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'Directory Listing'</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#root">root</a>(self):</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">if</span> self.main:</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">            url = self.directory_layout.index()</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">            url = self.directory_layout.special(<span class="py-string">'dir'</span>)</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        <span class="py-keyword">return</span> url, self.title()</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#filename_for_dir">filename_for_dir</a>(self, dir):</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns the output filename for the given input directory.&quot;&quot;&quot;</span></span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        <span class="py-keyword">if</span> dir == self.src_dir:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">            <span class="py-keyword">return</span> self.root()[0]</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">            scope = rel(self.src_dir, dir).split(os.sep)</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">            <span class="py-keyword">return</span> self.directory_layout.scoped_special(<span class="py-string">'dir'</span>, scope)</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#register">register</a>(self, frame):</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        View.register(self, frame)</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        self._exclude = [compile_glob(e) <span class="py-keyword">for</span> e <span class="py-keyword">in</span> self.exclude]</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        self.__filename = self.root()[0]</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#register_filenames">register_filenames</a>(self):</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        dirs = [self.src_dir]</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-keyword">while</span> dirs:</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">            dir = dirs.pop(0)</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">            <span class="py-keyword">for</span> entry <span class="py-keyword">in</span> os.listdir(os.path.abspath(dir)):</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">                exclude = 0</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                <span class="py-keyword">for</span> re <span class="py-keyword">in</span> self._exclude:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                    <span class="py-keyword">if</span> re.match(entry):</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                        exclude = 1</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                        <span class="py-keyword">break</span></span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">                <span class="py-keyword">if</span> exclude:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">                entry_path = os.path.join(dir, entry)</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">                <span class="py-keyword">if</span> os.path.isdir(entry_path):</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">                    filename = self.filename_for_dir(dir)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">                    self.processor.register_filename(filename, self, entry_path)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">                    dirs.append(entry_path)</span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#process">process</a>(self):</span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        self.process_dir(self.src_dir)</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#process_dir">process_dir</a>(self, path):</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-comment"># Find the filename</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        self.__filename = self.filename_for_dir(path)</span>
<a id="line90"></a><span class="lineno"> 90</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-comment"># Start the file</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        self.start_file()</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        self.write_navigation_bar()</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        <span class="py-comment"># Write intro stuff</span></span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        root = <span class="py-string">''</span></span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        <span class="py-keyword">if</span> self.base_path != self.src_dir:</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">            rel(self.base_path, self.src_dir)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> len(root) <span class="py-keyword">or</span> root[-1] != <span class="py-string">'/'</span>: root = root + <span class="py-string">'/'</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">if</span> path <span class="py-keyword">is</span> self.src_dir:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            self.write(<span class="py-string">'&lt;h1&gt; '</span>+root)</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            self.write(<span class="py-string">'&lt;h1&gt;'</span> + href(self.root()[0], root + <span class="py-string">' '</span>))</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">            dirscope = []</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            scope = rel(self.src_dir, path).split(os.sep)</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            <span class="py-keyword">for</span> dir <span class="py-keyword">in</span> scope[:-1]:</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">                dirscope.append(dir)</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">                dirlink = self.directory_layout.scoped_special(<span class="py-string">'dir'</span>, dirscope)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                dirlink = rel(self.filename(), dirlink)</span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                self.write(href(dirlink, dir+<span class="py-string">'/ '</span>))</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">            <span class="py-keyword">if</span> len(scope) &gt; 0:</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                self.write(scope[-1]+<span class="py-string">'/'</span>)</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        self.write(<span class="py-string">' - Directory listing&lt;/h1&gt;'</span>)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-comment"># Start the table</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        self.write(<span class="py-string">'&lt;table summary=&quot;Directory Listing&quot;&gt;\n'</span>)</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        self.write(<span class="py-string">'&lt;tr&gt;&lt;th align=left&gt;Name&lt;/th&gt;'</span>)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        self.write(<span class="py-string">'&lt;th align=&quot;right&quot;&gt;Size (bytes)&lt;/th&gt;'</span>)</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        self.write(<span class="py-string">'&lt;th align=&quot;right&quot;&gt;Last modified (GMT)&lt;/th&gt;&lt;/tr&gt;\n'</span>)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-comment"># List all files in the directory</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        entries = os.listdir(os.path.abspath(path))</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        entries.sort()</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        files = []</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        dirs = []</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        <span class="py-keyword">for</span> entry <span class="py-keyword">in</span> entries:</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">         exclude = 0</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">         <span class="py-keyword">for</span> re <span class="py-keyword">in</span> self._exclude:</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">            <span class="py-keyword">if</span> re.match(entry):</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">               exclude = 1</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">               <span class="py-keyword">break</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line">         <span class="py-keyword">if</span> exclude:</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">            <span class="py-keyword">continue</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">         entry_path = os.path.join(path, entry)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">         info = os.stat(entry_path)</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">         <span class="py-keyword">if</span> stat.S_ISDIR(info[stat.ST_MODE]):</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">            <span class="py-comment"># A directory, process now</span></span>
<a id="line137"></a><span class="lineno">137</span><span class="line">            scope = rel(self.src_dir, entry_path).split(os.sep)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">            linkpath = self.directory_layout.scoped_special(<span class="py-string">'dir'</span>, scope)</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">            linkpath = rel(self.filename(), linkpath)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">            self.write(<span class="py-string">'&lt;tr&gt;&lt;td&gt;%s&lt;/td&gt;&lt;td&gt;&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;%s&lt;/td&gt;&lt;/tr&gt;\n'</span>%(</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">               href(linkpath, entry+<span class="py-string">'/'</span>),</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">               time.asctime(time.gmtime(info[stat.ST_MTIME]))))</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            dirs.append(entry_path)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">            files.append((entry_path, entry, info))</span>
<a id="line146"></a><span class="lineno">146</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        <span class="py-keyword">for</span> path, entry, info <span class="py-keyword">in</span> files:</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            size = info[stat.ST_SIZE]</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            timestr = time.asctime(time.gmtime(info[stat.ST_MTIME]))</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">            <span class="py-comment"># strip of base_path</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line">            path = path[len(self.base_path):]</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">            <span class="py-keyword">if</span> path[0] == <span class="py-string">'/'</span>: path = path[1:]</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            linkpath = self.directory_layout.file_source(path)</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">            rego = self.processor.filename_info(linkpath)</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">            <span class="py-keyword">if</span> rego:</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                linkurl = rel(self.filename(), linkpath)</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                self.write(<span class="py-string">'&lt;tr&gt;&lt;td&gt;%s&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;%d&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;%s&lt;/td&gt;&lt;/tr&gt;\n'</span>%(</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">                    href(linkurl, entry, target=<span class="py-string">'content'</span>), size, timestr))</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                <span class="py-comment"># print &quot;No link for&quot;,linkpath</span></span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                self.write(<span class="py-string">'&lt;tr&gt;&lt;td&gt;%s&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;%d&lt;/td&gt;&lt;td align=&quot;right&quot;&gt;%s&lt;/td&gt;&lt;/tr&gt;\n'</span>%(</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">                    entry, size, timestr))</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-comment"># End the table and file</span></span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        self.write(<span class="py-string">'&lt;/table&gt;'</span>)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        self.end_file()</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        <span class="py-comment"># recursively create all child directory views</span></span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        <span class="py-keyword">for</span> dir <span class="py-keyword">in</span> dirs:</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">            self.process_dir(dir)</span>
<a id="line170"></a><span class="lineno">170</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Directory/Directory.html#end_file">end_file</a>(self):</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Overrides end_file to provide synopsis logo&quot;&quot;&quot;</span></span>
<a id="line173"></a><span class="lineno">173</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        now = time.strftime(<span class="py-string">r'%c'</span>, time.localtime(time.time()))</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        logo = img(src=rel(self.filename(), <span class="py-string">'synopsis.png'</span>), alt=<span class="py-string">'logo'</span>)</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        logo = href(<span class="py-string">'http://synopsis.fresco.org'</span>, logo + <span class="py-string">' synopsis'</span>, target=<span class="py-string">'_blank'</span>)</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        logo += <span class="py-string">' (version %s)'</span>%config.version</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        self.write(div(<span class="py-string">'logo'</span>, <span class="py-string">'Generated on '</span> + now + <span class="py-string">' by \n&lt;br/&gt;\n'</span> + logo))</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        View.end_file(self)</span>
<a id="line181"></a><span class="lineno">181</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
